<template>
  <div class="album-list">
    <div class="btn-group mb-2" role="group" v-if="showManageAlbums">
      <button v-if="showManageAlbumsButton" type="button" class="btn btn-primary" @click="onClickManage">
        <i class="bi bi-list-task"></i>
        Manage albums
      </button>
      <button v-if="managing" type="button" class="btn btn-primary" @click="onClickFinish">
        <i class="bi bi-check-lg"></i>
        Finish
      </button>
    </div>
    <div class="album-list-albums clearfix">
      <component
        v-for="album in albums"
        :key="album.id"
        :album="album"
        :active="album.alias === alias"
        :managing="managing"
        :selecting="selecting"
        :is="itemComponent"
        @album-long-press="onAlbumLongPress"
        @album-selected="onAlbumSelected"
      />
      <div v-if="albums.length === 0 && !loading">No albums found.</div>
    </div>
    <FixedFooter v-if="managing" @close="onManagingFixedFooterClose">
      <AlbumListManaging :albums="albums" :alias="alias" @button="onButton" />
    </FixedFooter>
    <SelectingFixedFooter v-if="selecting" />
  </div>
</template>

<script>
import { ref, computed } from 'vue'
import { useRouter } from 'vue-router'
import { useStore } from 'vuex'
import { FixedFooter, useApi, useConfirmPrompt, useNotification } from '../../core'
import { useAuth } from '../../identity'
import AlbumsApi from '../api/albums-api.js'
import AlbumListManaging from './album-list-managing.vue'
import AlbumListItemGalleryView from './album-list-item-galleryview.vue'
import AlbumListItemSidebarView from './album-list-item-sidebarview.vue'
import SelectingFixedFooter from './selecting-fixed-footer.vue'

export default {
  name: 'AlbumList',
  emits: ['albumSelected', 'stale'],
  components: {
    FixedFooter,
    AlbumListManaging,
    AlbumListItemGalleryView,
    AlbumListItemSidebarView,
    SelectingFixedFooter,
  },
  props: {
    username: { type: String, required: true },
    albums: { type: Array, required: true },
    view: { type: String, default: 'gallery' },
    alias: { type: String, default: '' },
    loading: { type: Boolean, default: false },
    selecting: { type: Boolean, default: false },
  },
  setup(props, context) {
    const router = useRouter()
    const store = useStore()
    const api = useApi()
    const auth = useAuth()
    const confirmPrompt = useConfirmPrompt()
    const notify = useNotification()
    const albumsApi = new AlbumsApi(api, auth)

    const managing = ref(false)

    const authenticatedUserId = computed(() => {
      return store.state.identity.session.userId
    })

    const authenticatedUsername = computed(() => {
      return store.state.identity.session.username
    })

    const isCurrentUser = computed(() => {
      return authenticatedUserId.value > 0 && authenticatedUsername.value === props.username
    })

    const showManageAlbums = computed(() => {
      return isCurrentUser.value && props.view === 'gallery'
    })

    const showManageAlbumsButton = computed(() => {
      return !managing.value && !props.selecting
    })

    const itemComponent = computed(() => {
      switch (props.view.toLowerCase()) {
        case 'sidebar':
          return 'AlbumListItemSidebarView'
        default:
          return 'AlbumListItemGalleryView'
      }
    })

    const onClickManage = () => {
      context.emit('albumSelected', null)
      managing.value = true
    }

    const onClickFinish = () => {
      managing.value = false
    }

    const onAlbumLongPress = () => {
      if (isCurrentUser.value && !props.selecting) {
        managing.value = true
      }
    }

    const onAlbumSelected = (album) => {
      context.emit('albumSelected', album)
    }

    const onManagingFixedFooterClose = () => {
      managing.value = false
    }

    const onSelectingFixedFooterClose = () => {
      cancelSelecting()
    }

    const onButton = async (code, args) => {
      switch (code) {
        case 'create-album':
          createAlbum(args.alias)
          break

        case 'edit-album':
          editAlbum(args.alias)
          break

        case 'delete-album':
          deleteAlbum(args.alias)
          break
      }
    }

    const onDeleteAlbumConfirmed = async (album) => {
      try {
        await albumsApi.deleteAsync(album.id)
        notify.success('The album has been deleted.')
        context.emit('stale')
      } catch (ex) {
        if (ex.response.status === 400) {
          notify.warning(ex.response.data.message)
        } else {
          notify.error('There was a problem deleting the album.', ex)
        }
      }
    }

    const createAlbum = () => {
      router.push({
        name: 'gallery-album-create',
        params: { username: props.username },
        query: { selecting: props.selecting ? 'true' : undefined },
      })
    }

    const editAlbum = (alias) => {
      router.push({
        name: 'gallery-album-edit',
        params: { username: props.username, alias },
        query: { selecting: props.selecting ? 'true' : undefined },
      })
    }

    const deleteAlbum = (alias) => {
      const album = props.albums.find((x) => x.alias === alias)
      const albumName = album ? album.displayName : alias

      confirmPrompt
        .show({
          text: `Really delete album "${albumName}" ?`,
        })
        .then(
          async () => {
            await onDeleteAlbumConfirmed(album)
          },
          () => {}
        )
    }

    const cancelSelecting = () => {
      // TODO: Redirect to return form.
    }

    return {
      managing,
      authenticatedUserId,
      authenticatedUsername,
      isCurrentUser,
      showManageAlbums,
      showManageAlbumsButton,
      itemComponent,
      onClickManage,
      onClickFinish,
      onAlbumLongPress,
      onAlbumSelected,
      onManagingFixedFooterClose,
      onSelectingFixedFooterClose,
      onButton,
    }
  },
}
</script>

<style lang="scss">
@use '../../core/sass/vars';

.album-list {
  margin-bottom: 2em;
}

.gallery {
  overflow: hidden;
  margin-right: -(vars.$gallerySpacing);
  margin-bottom: -(vars.$gallerySpacing);
}

// Larger displays
@media only screen and (min-width: vars.$sm) {
  .gallery {
    margin-right: -(vars.$gallerySpacingLarge);
    margin-bottom: -(vars.$gallerySpacingLarge);
  }
}
</style>
